-------------------------------------------------------------+
-- Copyright  2013 Rafa Mikoajun (MIKO) | rafal@mikoweb.pl
-- license: GNU General Public License version 3 or later; see LICENSE.txt
--
-- www.mikoweb.pl
-- www.swiat-ls.pl
--
-- Gauges Mod
-- Trailer Physics Specialization
--
-- Poprawiona fizyka przyczepy:
-- 	* cignik jedzie wolniej pod wpywem ciaru przyczepy
--	* przyczepa opada pod wpywem ciaru adunku 
------------------------------------------------------------*/

trailerPhysics = {};

function trailerPhysics.prerequisitesPresent(specializations)
	return true;
end;

function trailerPhysics:load(xmlFile)
	self.trailers = {}
	self.getTrailers = SpecializationUtil.callSpecializationsFunction("getTrailers");
	self.downForceMax = self.downForce;
end;

function trailerPhysics:delete()

end;

function trailerPhysics:mouseEvent(posX, posY, isDown, isUp, button)
end;

function trailerPhysics:keyEvent(unicode, sym, modifier, isDown)
end;

function trailerPhysics:update(dt)
	if self:getIsActive() then
		self:getTrailers(self.attachedImplements); -- zliczanie przyczep
		if self.trailers ~= nil then
			local driveMode = Steerable.realisticPhysics.gearboxSettings.driveMode; -- drogowe czy terenowe
			local trailersNum = table.getn(self.trailers); -- liczba przyczep
			local trailersWeight = 0; -- cakowita waga pustych przyczep
			if trailersNum>0 then
				for _, trailer in pairs(self.trailers) do  
					trailersWeight = trailersWeight+trailer.object.emptyMass;
					
					--[[ Nowa sia docisku przyczepy --]]
					local difference = trailer.object.currentMass-trailer.object.emptyMass;
					if difference>0 then
						if driveMode==0 then
							--trailer.object.downForce = 10*(math.pow(1+difference, 2));
							if trailer.object.downForce>20 then 
								Steerable.realisticPhysics.gearboxSettings.driveModeTerrainIncrease = true;
							else 
								Steerable.realisticPhysics.gearboxSettings.driveModeTerrainIncrease = nil;
							end;
						--else
						end;
						trailer.object.downForce = 10*(math.pow(1+difference, 3)); -- nowy docisk zaley od wagi przyczepy z obcieniem
					else
						Steerable.realisticPhysics.gearboxSettings.driveModeTerrainIncrease = nil;
						trailer.object.downForce = 10;
					end;
				end;
				if trailersWeight>0 then 
					--[[ Nowa sia docisku pojazdu --]]
					if driveMode==0 then -- na terenowych
						self.downForce = self.downForceMax/1.5; 
					else
						self.downForce = (self.downForceMax/(1.5+trailersWeight))-5;  -- nowy docisk zaley od cakowitej wagi pustych przyczep
					end;					
				end;
			else 
				self.downForce = self.downForceMax; -- jeli brak przyczep ustaw domyln warto docisku
				Steerable.realisticPhysics.gearboxSettings.driveModeTerrainIncrease = nil;
			end;
		end;
	end;
end;

function trailerPhysics:updateTick(dt)
end;

function trailerPhysics:draw()
end;

function trailerPhysics:getTrailers(attachedImplements, recursive)
	if recursive==nil then self.trailers = {} end;
	if attachedImplements ~= nil and table.getn(attachedImplements)>0 then
		for _, trailer in pairs(attachedImplements) do  
			if trailer.object ~= nil then
				if trailer.object.currentMass ~= nil and trailer.object.emptyMass ~= nil and trailer.object.downForce ~= nil then
					table.insert(self.trailers, trailer);
					self:getTrailers(trailer.object.attachedImplements, true);
				end;
			end;
		end;	
	end;
end;

